/********************************************/
/* SCR2TAP                                	*/
/*											*/
/* (c)2000 Ignacio Burgueo					*/
/* e-mail: burguer1@adinet.com.uy			*/
/********************************************/
#include "stdio.h"
#include "malloc.h"
#include "string.h"

#define	FALSE	0
#define	TRUE	1

int ParseCommandLine(int argc, char* argv[]);
int OpenSCR(char* filename);
int WriteTAP(char* filename);
void Instructions();
void Terminar();

unsigned char* bufferSCR = NULL;

unsigned char cabecera[] = {
	0x13, 0x00, 0x00, 0x00, 0x73, 0x63, 0x72, 0x32, 0x74, 0x61, 0x70, 0x20, 0x20, 0x20, 0x16, 0x00,
	0x0a, 0x00, 0x16, 0x00, 0x1f, 0x18, 0x00, 0xff, 0x00, 0x0a, 0x05, 0x00, 0xef, 0x22, 0x22, 0xaa,
	0x0d, 0x00, 0x14, 0x09, 0x00, 0xf2, 0x30, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x64, 0x13,
	0x00, 0x00, 0x03, 0x73, 0x63, 0x72, 0x65, 0x65, 0x6e, 0x20, 0x20, 0x20, 0x20, 0x00, 0x1b, 0x00,
	0x40, 0x61, 0x80, 0xb5, 0x02, 0x1b, 0xff
};

////////////////////////////////////////////////////////////////////////////////////////////////////
int main(int argc, char* argv[]) {
	int retorno;

	if(argc == 1) { /*No se pasaron parmetros*/
		Instructions();
		return 0;
	};
	if(ParseCommandLine(argc, argv)) {
		printf("Conversion exitosa.");
		retorno = 0;
	}
	else {
		printf("Error en la conversion.");
		retorno = 1;
	};
	return retorno;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
int ParseCommandLine(int argc, char* argv[]) {
	char nombre[257];
	int retorno;

	if(argc == 1 || argc > 3) {
		Instructions();
		return FALSE;
	};
	if(OpenSCR(argv[1])) {
		if(argc == 2) {
			/*Nombre de TAP por defecto*/
			argv[1] = strtok(argv[1], ".");
			strcpy(nombre, argv[1]);
			strcat(nombre, ".tap");;
		}
		else
			strcpy(nombre, argv[2]);
		if(WriteTAP(nombre))
			retorno = TRUE;
		else
			retorno = FALSE;
	}
	else
		retorno = FALSE;
	/*Libero la memoria ubicada y me voy*/
	Terminar();
	return retorno;
};

////////////////////////////////////////////////////////////////////////////////////////////////////
int OpenSCR(char* filename) {
	FILE* fileSCR;

	if((bufferSCR = (unsigned char*)malloc(8192)) == NULL)
		return FALSE; /*No hay memoria disponible*/
	if((fileSCR = fopen(filename, "rb")) == NULL) {
		printf("ERROR: El archivo de origen no existe.\n");
		return FALSE;
	};
	rewind(fileSCR);
	fread(bufferSCR, 1, 6912, fileSCR);
	fclose(fileSCR);
	return TRUE;
};

////////////////////////////////////////////////////////////////////////////////////////////////////
int WriteTAP(char* filename) {
	FILE* tapDestino;
	unsigned char checksum = 0;
	int i;

	if((tapDestino = fopen(filename, "wb")) == NULL) {
		printf("ERROR: El archivo de destino no existe.\n");
		return FALSE;
	};
	rewind(tapDestino);
	fwrite(cabecera, 1, 71, tapDestino);	/*Escribo el programa BASIC*/
	fwrite(bufferSCR, 1, 6912, tapDestino);	/*Escribo la pantalla*/
	for(i = 0; i < 6912; i++)
		checksum ^= bufferSCR[i];
	checksum ^= 0xff;
	fwrite(&checksum, 1, 1, tapDestino);	/*Escribo el checksum*/
	fclose(tapDestino);
	return TRUE;
};

////////////////////////////////////////////////////////////////////////////////////////////////////
void Instructions() {
	printf("SCR2TAP\n");
	printf("=======\n\n");
	printf("Este programa convierte un archivo SCR (snapshots de pantalla de Spectrum)\n");
	printf("a un archivo TAP (formato de cinta de Spectrum). El TAP contiene un pequeno\n");
	printf("cargador en BASIC que carga la pantalla y espera a que se pulse una tecla.\n\n");
	printf("La sintaxis de SCR2TAP es:\n\n");
	printf("SCR2TAP origen.scr [destino.tap]\n\n\n");
	printf("(c)2000 Ignacio Burgueno\n");
	printf("e-mail: burguer1@adinet.com.uy\n");
};

////////////////////////////////////////////////////////////////////////////////////////////////////
void Terminar() {
	if(bufferSCR != NULL)
		free(bufferSCR);
};